
const SCORM_OPTIONS = {
    constants: {
        completed: 'completed',
        incomplete: 'incomplete',
        passed: 'passed',
        failed: 'failed'
    },
    // status connection 
    connection_status: false,
    // start time
    start_time: null
}
const SCORM = pipwerks.SCORM;
window.parent.API_SCORM = SCORM;
// pagina llamada para iniciar conexion
function SCORMInitializate(){
    let conectionStatus = SCORM.init();
    SCORM_OPTIONS.connection_status = conectionStatus;
    console.log('SCORM Connection status: ', conectionStatus);
    console.log('SCORM Completion status', SCORM.GetCompletionStatus());
    console.log('SCORM Success status', SCORM.GetSuccessStatus());

    SCORMMarkerCompleted(false);
    SCORM.save();

    // init the time
    SCORMInitTime()
}


function SCORMInitTime(){
    SCORM_OPTIONS.start_time = new Date().getTime();
}
function SCORMComputerTime(){
    let formattedTime;
    if(SCORM_OPTIONS.start_time != 0){
        let startDate = SCORM_OPTIONS.start_time;
        let currentDate = new Date().getTime();
        let elapsedMiliSeconds = currentDate - startDate;
        formattedTime = pipwerks.UTILS.convertTotalMiliSeconds(elapsedMiliSeconds);
    } else {
        formattedTime = pipwerks.UTILS.convertTotalMiliSeconds(0);
    }
    SCORM.SetSessionTime(formattedTime)
}

function SCORMMarkerCompleted(isCompleted=true){
    if(isCompleted){
        SCORM.SetCompletionStatus(SCORM_OPTIONS.constants.completed);
        SCORM.SetSuccessStatus(SCORM_OPTIONS.constants.passed);
    } else {
        SCORM.SetCompletionStatus(SCORM_OPTIONS.constants.incomplete);
        SCORM.SetSuccessStatus(SCORM_OPTIONS.constants.failed);
    }
}
function SCORMFinalizate(){
    SCORMComputerTime();
    SCORM.save();
    SCORM.quit();

}
function SCORMRestoreLocation(callback,identifiedUsed=null){
    let location_scorm = SCORM.GetLessonLocation();
    if(!location_scorm){
        return false;
    }
    console.log('SCORM location: ', location_scorm);
    
    callback(location_scorm, identifiedUsed);
}
function SCORMSetIfLocationMax(location_scorm){
    location_saved = SCORM.GetLessonLocation();
    if(!location_saved || (Number(location_saved) < location_scorm)){
        SCORM.SetLessonLocation(location_scorm);
    }
}
// uso para multiple sco
function SCORMGoBack() {
    pipwerks.nav.goBack();
}
  
function SCORMGoNext() {
    pipwerks.nav.goForward();
}
// only SCORM v2004
function SCORMGoItem(identifier){
    pipwerks.nav.gotToItem(identifier);
}